
/* List view is already a component */

ListView = Vue.component('list-view', (
{
  data: function() {
    return { entrylist: this.$parent.entrylist } // BAD IDEA: replace with store
  },
  template: 
  `
  <div class="three columns">
  <ul><list-item v-for="item in entrylist" :key="item.id" :idnum="item.id" :name="item.name"></list-item></ul>
  </div>
  `,
}
))


/* nice component */
Vue.component( 'list-item', (
  {
    props: [ 'idnum', 'name'],
    computed: {
      addr: function() {
        return "#/item/" + this.idnum;
      }
    },
    template: '<li><a :href="addr">{{name}}</a></li>'
  }
))

const Add = Vue.component('add-view', ({ 
  
  data: function() {
    return { 
      entrylist: this.$parent.entrylist, // BAD IDEA: replace with store 
      name: "",
      fav: ""
     } 
  },
  methods: {
    addNew: function() {
      this.entrylist.push({id:3, name:this.name})
      this.name = "";
    }
  },
  template: 
  `
  <div>
  <h2>Lisamine</h2>
  <form>
  <input type="text" id="name" v-model="name"/>
  <input type="submit" @click="addNew"/>
  </form>
  </div>
  `
}
))

/* APPLICATION STATE */

/* 

NOTE: bad idea to use it for sharing data directly. We should
be sharing it using a store.

*/

const appstate = 
    { 
      entrylist: [
        { id:1, name:"asd"},
        { id:0, name:"dsa"}
      ]
    }


/* ROUTER ELEMENTS */
routes = [
  { path: '/list', component: ListView },
  { path: '/add', component: Add },
  { path: '/item/:id', component: {template: '<div><h1>Details {{$route.params.id}}</h1><div></div></div>'} } // change into a proper component
]

const router = new VueRouter(
  {routes, linkActiveClass: "button-primary"}
)

/* ADD STORE HERE*/
Vue.use(Vuex)

// store needs an alchemist list with
// a mutator to add alchemists
// a getter for a free alchemist in it and a getter which filters only Water alchemists


/* VUE APP */

var vm = new Vue(
{ 
  router,
  // store, // provides this.$store object to the components, but you need to create store obj first
  data: appstate
}
).$mount('#app');
